﻿using HttpContextTest;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using Microsoft.VisualStudio.TestTools.UnitTesting.Web;
using System.Web;
using System.IO;
using HttpContextTool;
using System.Collections.Specialized;

namespace HttpContextTest.UnitTest
{


    /// <summary>
    ///This is a test class for FileUploadTest and is intended
    ///to contain all FileUploadTest Unit Tests
    ///</summary>
    [TestClass()]
    public class FileUploadTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        ///A test for ProcessRequest
        ///</summary>
        // TODO: Ensure that the UrlToTest attribute specifies a URL to an ASP.NET page (for example,
        // http://.../Default.aspx). This is necessary for the unit test to be executed on the web server,
        // whether you are testing a page, web service, or a WCF service.
        [TestMethod()]
        public void ProcessRequestTest()
        {
            FileUpload target = new FileUpload(); // TODO: Initialize to an appropriate value
            HttpContext context = null; // TODO: Initialize to an appropriate value

            //初始化环境
            HttpRequest request = new HttpRequest("FileUpload.ashx", "http://localhost", "");
            StringWriter writer = new StringWriter();
            HttpResponse response = new HttpResponse(writer);
            context = new HttpContext(request, response);
            HttpContext.Current = context;


            NameValueCollection serVar = new NameValueCollection();
            serVar.Set("server", "dd");
            HttpContextHelper.SetServerVar(context, serVar);


            //设置form参数
            NameValueCollection form = new NameValueCollection();
            form.Set("token", Guid.Empty.ToString());
            HttpContextHelper.SetForm(context, form);

            //设置session
            HttpContextHelper.SetSession(context, HttpContextHelper.CreateSession());
            context.Session["userid"] = Guid.NewGuid().ToString();

            //设置查询字符串
            NameValueCollection queryString = new NameValueCollection();
            queryString.Set("timestamp", DateTime.Now.ToString("ddmmss"));
            HttpContextHelper.SetQueryString(context, queryString);

            //设置上传文件
            byte[] data = File.ReadAllBytes(@"Penguins.jpg");
            HttpContextHelper.SetFile(context, "file", "multipart/form-data", "Penguins.jpg", data);

            target.ProcessRequest(context);

            //Assert.Inconclusive("A method that does not return a value cannot be verified.");
        }
    }
}
