﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

namespace HttpContextTool
{

    [Serializable]
    public class AmbiguousMethodNameException : Exception
    {
        private const string c_errorMessage = "Method name \"{0}\" is ambiguous in type {1}.";

        public AmbiguousMethodNameException(string methodName, Type type)
            : this(string.Format(c_errorMessage, methodName, type.FullName))
        {
        }

        public AmbiguousMethodNameException(string message)
            : base(message)
        {
        }

        protected AmbiguousMethodNameException(SerializationInfo info, StreamingContext context)
            : base(info, context)
        {
        }
    }
}
