﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

namespace HttpContextTool
{
    [Serializable]
    public class MethodNotFoundException : Exception
    {
        private const string c_errorMessage = "There is no method \"{0}\" in type {1} that accepts the specified argument types.";

        public MethodNotFoundException(string methodName, Type type)
            : this(string.Format(c_errorMessage, methodName, type.FullName))
        {
        }

        public MethodNotFoundException(string message)
            : base(message)
        {
        }

        protected MethodNotFoundException(SerializationInfo info, StreamingContext context)
            : base(info, context)
        {
        }
    }
}
